#ifndef CHARTS_H
#define CHARTS_H

#include <QtCore>
#include <QtGui>

#include "ui_charts.h"
#include "qexchange.h"
#include <qwt_scale_draw.h>
#include <qwt_text.h>
#include <qwt_plot_item.h>
#include <qwt_plot_zoomer.h>
#include <qwt_double_rect.h>

class ChartDateScale : public QwtScaleDraw
{
public:
  QwtText label(double value) const
    { return QDateTime::fromTime_t(value).date().toString(Qt::ISODate);  }
};

class ChartNoPlot : public QwtPlotItem
{
public:
  ChartNoPlot() : QwtPlotItem() { }

  int rtti() const
    { return QwtPlotItem::Rtti_PlotCurve; }

  void draw(QPainter *painter, const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QRect &canvasRect) const;
};

class ChartDateZoomer : public QwtPlotZoomer
{
protected:
  QwtText trackerText(const QwtDoublePoint &point) const
    { return QDateTime::fromTime_t(point.x()).date().toString(Qt::ISODate) + "," +
             QString::number(point.y()); }

public:
  ChartDateZoomer(QwtPlotCanvas *canvas) : QwtPlotZoomer(canvas) { }
};

class ChartDialog : public QDialog, public Ui::ChartDialog
{
  Q_OBJECT

  double *xData;
  double *yData;
  QExchange *module;
  ChartDateZoomer *zoomer;

private slots:
  void replot();

public:
  ChartDialog(QExchange *exchangeModule, QWidget *parent = 0);
  virtual ~ChartDialog();
};

#endif
