#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtCore>
#include <QtGui>

#include "ui_mainwindow.h"
#include "qexchange.h"

class MainWindow : public QMainWindow, public Ui::MainWindow
{
  Q_OBJECT

  bool convertLeftToRight;
  bool skipSignal;
  QMap<QString,QString> currencyNames;
  QExchange *module;
  QLabel *statusMsg;
  QProgressDialog *progressDlg;

private slots:
  void on_actionChart_triggered();
  void on_actionAbout_triggered();
  void on_leLeftValue_textChanged(const QString &text);
  void on_leRightValue_textChanged(const QString &text);
  void on_cbLeftCurrency_currentIndexChanged(int index);
  void on_cbRightCurrency_currentIndexChanged(int index);
  void on_deExchangeDate_dateChanged(const QDate &date);
  void reload();
  void reloadAll();
  void recalculate();
  void downloadStarted();
  void downloadFailed();
  void downloadCompleted();
  void on_actionPreferences_triggered();
  void showStoreProgress(int step, int current, int total);
  void showDownloadProgress(int step, int current, int total);

public:
  MainWindow(QExchange *exchangeModule, QWidget *parent = 0);
};

#endif
