#ifndef PREFERENCESDLG_H
#define PREFERENCESDLG_H

#include <QtCore>
#include <QtGui>

#include "ui_preferences.h"

class PreferencesDialog : public QDialog, public Ui::PreferencesDialog
{
  Q_OBJECT

  QMap<QString,QVariant> _settings;
  QMap<QString,QVariant> bkpSettings;

  void reloadSettings();

private slots:
  void on_cbSaveLastCurrencySetting_toggled(bool checked)
    { _settings["loadLastCurrencySetting"] = checked; }
  void on_cbAutoUpdate_toggled(bool checked)
    { _settings["updateOnStart"] = checked; }
  void on_rbUseProxy_toggled(bool checked)
    { _settings["useProxy"] = checked; }
  void on_leProxyHost_textChanged(const QString &text)
    { _settings["proxyHost"] = text; }
  void on_sbProxyPort_valueChanged(int i)
    { _settings["proxyPort"] = i; }
  void on_leProxyUsername_textChanged(const QString &text)
    { _settings["proxyUsername"] = text; }
  void on_leProxyPassword_textChanged(const QString &text)
    { _settings["proxyPassword"] = text; }
  void on_cbProxyType_currentIndexChanged(int index)
    { _settings["proxyType"] = cbProxyType->itemData(index).toInt(); }
  void on_buttonBox_clicked(QAbstractButton *button);

public:
  PreferencesDialog(QWidget *parent = 0);

  void setSettings(const QMap<QString,QVariant> &mainSettings)
    { bkpSettings = mainSettings; reloadSettings(); }

  QMap<QString,QVariant> settings() const
    { return _settings; }
};

#endif
