#include <QtCore>
#include <QtGui>
#include <QtNetwork>

#include "preferencesdlg.h"

PreferencesDialog::PreferencesDialog(QWidget *parent) : QDialog(parent)
{
  setupUi(this);

  cbProxyType->addItem("HTTP",QNetworkProxy::HttpProxy);
  cbProxyType->addItem("SOCKS 5",QNetworkProxy::Socks5Proxy);
  cbProxyType->setCurrentIndex(0);

  layout()->setSizeConstraint(QLayout::SetFixedSize);
}

void PreferencesDialog::reloadSettings()
{
  _settings = bkpSettings;

  cbSaveLastCurrencySetting->setChecked(_settings["loadLastCurrencySetting"].toBool());
  cbAutoUpdate->setChecked(_settings["updateOnStart"].toBool());
  if (_settings["useProxy"].toBool())
    rbUseProxy->setChecked(true);
  else
    rbDirectConnection->setChecked(true);
  leProxyHost->setText(_settings["proxyHost"].toString());
  sbProxyPort->setValue(_settings["proxyPort"].toInt());
  leProxyUsername->setText(_settings["proxyUsername"].toString());
  leProxyPassword->setText(_settings["proxyPassword"].toString());
  cbProxyType->setCurrentIndex(cbProxyType->findData(_settings["proxyType"]));
}

void PreferencesDialog::on_buttonBox_clicked(QAbstractButton *button)
{
  if (buttonBox->buttonRole(button) == QDialogButtonBox::ResetRole)
    reloadSettings();
}
